<?php
namespace Teknisa\CNC\Controllers;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request;
use Teknisa\CNC\Services;
use Teknisa\CNC\Utilities;

class AdquirenteCNC extends \Zeedhi\Framework\Controller\Simple {
    
    protected $adquirenteService;
    protected $salesMessage;
    
    public function __construct(Services\AdquirenteCNC $adquirenteService, Utilities\SalesMessageCNC $salesMessage) {
        $this->adquirenteService = $adquirenteService;
        $this->salesMessage      = $salesMessage;
    }
    
    public function getAcquirers(Request\Filter $request, Response $response){
        try {
            $row = $request->getFilterCriteria()->getConditions();
            $newRow = [];
            $newRow["LABELADQUIRENTE"] = !isset($row[0]["value"]) || empty($row[0]["value"])
                    ? "" 
                    :  (isset($row[0]["value"][0]['_ALL']) 
                        ? $row[0]["value"][0]['_ALL'] 
                        : $row[0]["value"][0] );
            
            $Produto = $this->adquirenteService->getAcquirers($newRow);
            
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('AdquirentesRepo', $Produto));
        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }

}