<?php

namespace Teknisa\CNC\Services;

use Teknisa\Libs\Util\Environment;
use Teknisa\CNC\Factories\Cnc00200AdquirentesFactory;
use Teknisa\CNC\Utilities\UtilCNC;

class Cnc00200AdquirentesService {
    protected $entityManager;
    protected $factory;
    protected $environment;
    protected $util;
    
    public function __construct (\Doctrine\ORM\EntityManager $entityManager,Environment $environment, Cnc00200AdquirentesFactory $factory, UtilCNC $util) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->factory = $factory;
        $this->util = $util;
    }
    
    public function getAdquirentesSeries ($params) {
        $result = $this->factory->getAdquirentesSeries(array(
            ":NRORG"        => $params["NRORG"],
            ":NRESTABELEC"  => $params["NRESTABELEC"]["value"]
        ));
        
        return $result;
    }
    
    public function getContcorrEmpresa ($params) {
        $result = $this->factory->getContcorrEmpresa(array(
            ":NRORG"        => $params["NRORG"]["value"],
            ":CDEMPRESA"    => $params["CDEMPRESA"]["value"]
        ));
        
        return $result;
    }
    
    public function getInscValues ($params) {
        $result = $this->factory->getInscValues(array(
            ":NRORG"        => $params["NRORG"],
            ":NRESTABELEC"  => $params["NRESTABELEC"]["value"]
        ));
        return $result;
    }

    public function insertLogAdqFinac ($params, $IDTIPO, $DSINFANTIGA, $DSINFNOVA) {
        $NRLOGFINESTADQ = $this->util->newCode('LOGFINESTADQ', '20');
        $NRLOGFINESTADQ = intval($NRLOGFINESTADQ);
        $result = $this->factory->insertLogAdqFinac(array(
            ":NRLOGFINESTADQ" => $NRLOGFINESTADQ,
            ":NRADQUIRENTE"   => $params["NRADQUIRENTE"],
            ":NRESTABELEC"    => $params["NMESTABELEC"],
            ":CDOPERADOR"     => $this->environment->getCdOperador(),
            ":IDTIPO"         => $IDTIPO,
            ":DSINFANTIGA"    => $DSINFANTIGA,
            ":DSINFNOVA"      => $DSINFNOVA
        ));
        return $result;
    }

    public function filterAdqFinacRow ($params) {
        $result = $this->factory->filterAdqFinacRow(array(
            ':NRORG' => $this->environment->getNrOrgTrab(),
            ':NRADQUIRENTE' => $params["NRADQUIRENTE"],
            ':NRESTABELEC' => $params["NMESTABELEC"]
        ));
        
        return $result;
    }
}